#!/usr/bin/perl -w

#   Copyright (C) 2006 David G. Jacobowitz 
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#

###########
#   NOTES:
#
#   This code, intended to be 'required' rather than used,
#   obtains a list of all the modules in the fgroup subdirectory,
#   loads all those modules, imports their exported functions into
#   this namespace, and generated an array "registerable_modules"
#   which consists of a list of all their names.

use constant MOD_DIR => "fgroup";

BEGIN {
 use FindBin;
 use lib $FindBin::Bin;
 opendir(F, $FindBin::Bin . "/" . MOD_DIR);
 my @pmods = readdir(F);
 closedir(F);
 my @mods  = ();
 @main::registerable_modules = ();
 foreach my $m (@pmods) {
  if ($m =~ /\.pm$/) {
   push(@mods,$m);
  }
 }
 foreach my $m (@mods) {
  require (MOD_DIR . "/$m");
  $m =~ s/\.pm$//;
  import $m;
  push(@main::registerable_modules, MOD_DIR . "::$m");
 }
};

1;

